<template>
  <div>
    <div class="text-h6 q-pa-sm">{{ $t("event_log_dialog.event_log") }}</div>
    <q-separator />
    <q-list separator>
      <q-item v-for="(event, key) in processedLogs" :key="key">
        <q-item-section>
          <q-item-label>{{ event.Message }}</q-item-label>
          <q-item-label caption>
            {{ formatDateTime(event.DateTime) }}
          </q-item-label>
        </q-item-section>
      </q-item>
    </q-list>
  </div>
</template>
<script>
import { DateTime } from "luxon";

export default {
  props: {
    events: {
      required: true,
    },
    hostName: {
      required: true
    }
  },
  computed: {
    processedLogs: function () {
      var reversedLogs = [];
      for (var logId in this.events) {
        let thisLog = this.events[logId].valueOf();
        thisLog.Message = this.getEventString(thisLog)
        if(thisLog.Message)
        {
          // don't list unless there's a string for this event type
          reversedLogs.splice(0, 0, thisLog);
        }        
      }
      return reversedLogs;
    }
  },
  methods: {
    formatDateTime(millis) {
      return DateTime.fromMillis(millis).toLocaleString(
        DateTime.DATETIME_MED_WITH_SECONDS
      );
    },
    getEventString(event) {
      let nameNum = event.Number == '1000' ? this.hostName + ` (${this.$t("conference.online")})`: 
                      (event.ContactName ? event.ContactName : this.$t("events.unknown_caller")) + ` (${event.Number})`;
      switch(event.Event) {
        case "conference-create":
          return this.$t("events.started")
        case "conference-destroy":
          return this.$t("events.ended")
        case "start-recording":
          return this.$t("events.recording_start")
        case "stop-recording":
          return this.$t("events.recording_complete")
        case "absent":
          return this.$t("events.recording_absent")
        case "add-member":
          return this.format(this.$t("events.joined"), [nameNum]);
        case 'kick-member':
        case "del-member":
          return this.format(this.$t("events.left"), [nameNum]);
        case "unmute-member":
          return this.format(this.$t("events.unmute"), [nameNum]);
        case "mute-member":
          return this.format(this.$t("events.mute"), [nameNum]);
        case "no-invite":
          return this.format(this.$t("events.rejected"), [nameNum]);
        case "capacity":
          return this.format(this.$t("events.capacity"), [nameNum]);
        case "dismiss-hand":
          return this.format(this.$t("events.dismiss_hand"), [nameNum]);    
        case "start-poll":
          return this.format(this.$t("events.start_poll"), [event.Title]);   
        case "end-poll":
          return this.format(this.$t("events.end_poll"), [event.Title]);   
        case "vote":
          return this.format(this.$t("events.voted"), [nameNum, event.Option]);  
        case "revote":
          return this.format(this.$t("events.revoted"), [nameNum, event.Option]); 
        case "anon_vote":
          return this.format(this.$t("events.anon_voted"), [event.Option]);  
        case "anon_revote":
          return this.format(this.$t("events.anon_revoted"), [event.Option]); 
        case 'hand_up':
          return this.format(this.$t("events.hand_up"), [nameNum]); 
        case 'hand_down':
          return this.format(this.$t("events.hand_down"), [nameNum]); 
        case 'waiting_retry':
          return this.format(this.$t("events.waiting_retry"), [nameNum, event.Delay / 1000]); 
        case 'retrying':
          return this.format(this.$t("events.retrying"), [nameNum, event.Attempt]); 
        case 'failed':
          return this.format(this.$t("events.failed"), [nameNum, this.$t("errors." + event.Error)]); 
        default:
          return null;
      }
    },
    format: function (string, args) {
        return string.replace(/{(\d+)}/g, (match, number)=> { 
            return typeof args[number] !== 'undefined'
              ? args[number]
              : match
            ;
          });
    },

  },
};
</script>